package com.sun.org.apache.xalan.internal.xsltc.compiler;

import com.sun.org.apache.bcel.internal.generic.BranchHandle;
import com.sun.org.apache.bcel.internal.generic.GOTO;
import com.sun.org.apache.bcel.internal.generic.InstructionList;
import com.sun.org.apache.xalan.internal.xsltc.compiler.util.MethodGenerator;
import com.sun.org.apache.xalan.internal.xsltc.compiler.util.ClassGenerator;
import java.util.List;

final class NotCall extends FunctionCall
{
    public NotCall(QName fname, List<Expression> arguments) {
        super(fname, arguments);
    }
    
    @Override
    public void translate(ClassGenerator classGen, MethodGenerator methodGen) {
        InstructionList il = methodGen.getInstructionList();
        this.argument().translate(classGen, methodGen);
        il.append(NotCall.ICONST_1);
        il.append(NotCall.IXOR);
    }
    
    @Override
    public void translateDesynthesized(ClassGenerator classGen, MethodGenerator methodGen) {
        InstructionList il = methodGen.getInstructionList();
        Expression exp = this.argument();
        exp.translateDesynthesized(classGen, methodGen);
        BranchHandle gotoh = il.append(new GOTO(null));
        this._trueList = exp._falseList;
        (this._falseList = exp._trueList).add(gotoh);
    }
}
